#include "HTMLView.h"

HTMLView :: HTMLView() : TopView(){
	show();
	SetResizeMask(CF_FOLLOW_ALL|WID_WILL_DRAW);
	Rect r = GetBounds();
	r.top +=2;
	r.bottom -=89;
	SetFrame(r);
	setPart(new KHTMLPart(this,"khtmlpart"));
	m_nCurHistoryPos=0;

}

HTMLView :: HTMLView(const std::string& cURL, const KParts::URLArgs& cArgs) : TopView(){
	show();
	SetResizeMask(CF_FOLLOW_ALL|WID_WILL_DRAW);
	Rect r = GetBounds();
	r.top +=2;
	r.bottom -=89;
	SetFrame(r);
	setPart(new KHTMLPart(this,"khtmlpart"));
	openURL(cURL,cArgs);
}

void HTMLView :: setPart(KHTMLPart* temp){
kpart = temp;
}


HistoryEntry* HTMLView::HistoryCurrent()
{
    if ( m_nCurHistoryPos >= 0 && m_nCurHistoryPos < int(m_cHistory.size()) ) {
	return( m_cHistory[m_nCurHistoryPos] );
    } else {
	return( NULL );
    }
}

KHTMLPart* HTMLView::getParts(){
return (kpart);
}

int HTMLView::getCHP(){
return (m_nCurHistoryPos);
}

void HTMLView::setCHP(int temp){
m_nCurHistoryPos=temp;
}

std::vector<HistoryEntry*> HTMLView::getHE(){
return (m_cHistory);
}

void HTMLView::openURL(const std::string& cURL, const KParts::URLArgs& cArgs){
kpart->browserExtension()->setURLArgs(cArgs);
kpart->openURL(cURL.c_str());
}

void HTMLView::AddHistoryEntry(){
if (m_cHistory.empty() == false && m_nCurHistoryPos == int(m_cHistory.size()) && 
m_cHistory[m_nCurHistoryPos-1]->m_cURL == kpart->url().prettyURL().utf8().data()) 
{
return;
}
m_nCurHistoryPos++;
for (uint i = m_nCurHistoryPos;i<m_cHistory.size();++i){
delete m_cHistory[i];
}
if ( m_nCurHistoryPos > 0){
m_cHistory.resize(m_nCurHistoryPos);
}
HistoryEntry* pcEntry = new HistoryEntry;
m_cHistory.push_back(pcEntry);
}

void HTMLView::GoHistory(int nStep)
{
m_nCurHistoryPos += nStep;

 
}
void HTMLView::UpdateHistory(HistoryEntry *temp)
{
m_nCurHistoryPos=m_cHistory.size();
m_cHistory.push_back(temp);
}
